#ifndef SEMANTICS_H
#define SEMANTICS_H

/// <summary>
/// Enum of the various semantics
/// </summary>
/// <remarks>
/// semantic indices are not included in this enum
/// </remarks>
enum Semantics
{
  SEM_BINORMAL,
  SEM_BLENDINDICES,
  SEM_BLENDWEIGHT,
  SEM_COLOR,
  SEM_DEPTH,
  SEM_FOG,
  SEM_NORMAL,
  SEM_POSITION,
  SEM_POSITIONT,
  SEM_PSIZE,
  SEM_TANGENT,
  SEM_TESSFACTOR,
  SEM_TEXCOORD,
  SEM_VFACE,
  SEM_VPOS,
};

/// <summary>
/// Converts entries of the Semantics enum to the string form of their name
/// </summary>
/// <param name="sem">
/// entry in Semantics to convert
/// </param>
/// <returns>
/// the corresponding string
/// </returns>
const char* GetSemanticName(Semantics sem);

#endif /* SEMANTICS_H */
