#include "Graphics/Buffers/IndexBuffer.h"
#include "log.h"

IndexBuffer::IndexBuffer(ID3D11Buffer* buffer)
:m_buffer(buffer)
{
}

IndexBuffer::~IndexBuffer()
{
  if (m_buffer)
  {
    m_buffer->Release();
  }
}

void IndexBuffer::MakeActive(ID3D11DeviceContext* context)
{
  context->IASetIndexBuffer(m_buffer,GetFormat(),0);
}

ID3D11Buffer* IndexBuffer::CreateBuffer(D3D11_Core& graphics,UINT num,
  UINT size,const void* data)
{
  ID3D11Buffer* back = NULL;
  
  ID3D11Device* device = graphics.GetDevice();
  
  D3D11_BUFFER_DESC bd;
  ZeroMemory(&bd,sizeof(bd));
  bd.Usage          = D3D11_USAGE_DEFAULT;
  bd.ByteWidth      = num * size;
  bd.BindFlags      = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA res_data;
  ZeroMemory(&res_data,sizeof(res_data));
  res_data.pSysMem = data;
  if (FAILED(device->CreateBuffer(&bd,&res_data,&back)))
  {
    log_print("Failed to create index buffer");
    return NULL;
  }
  
  return back;
}
