#include "Graphics/Buffers/VertexBufferArray.h"
#include "log.h"

VertexBufferArray::VertexBufferArray(UINT num_buffers)
:m_num(num_buffers)
{
  // create the arrays and init them to 0/NULL
  m_buffer = new ID3D11Buffer*[m_num];
  memset(m_buffer,0,sizeof(ID3D11Buffer*) * m_num);
  m_strides = new UINT[m_num];
  memset(m_strides,0,sizeof(UINT) * m_num);
  m_offsets = new UINT[m_num];
  memset(m_offsets,0,sizeof(UINT) * m_num);
}

VertexBufferArray::~VertexBufferArray()
{
  delete[]m_buffer;
  delete[]m_strides;
  delete[]m_offsets;
}

void VertexBufferArray::Set(UINT index,const VertexBuffer& buffer)
{
  m_buffer[index]  = buffer.m_buffer;
  m_strides[index] = buffer.GetStride();
  m_offsets[index] = 0;
}

void VertexBufferArray::Clear(UINT index)
{
  m_buffer[index]  = NULL;
  m_strides[index] = 0;
}

void VertexBufferArray::MakeActive(ID3D11DeviceContext* context)
{
  context->IASetVertexBuffers(0,m_num,m_buffer,m_strides,m_offsets);
}
