#include "Graphics/RenderPipeline.h"

RenderPipeline::RenderPipeline(VertexShader* vertex,PixelShader* pixel,
  BlendState* blend,DepthStencilState* depth)
:m_vertex(vertex),
 m_pixel(pixel),
 m_blend(blend),
 m_depth(depth)
{
}

RenderPipeline::~RenderPipeline()
{
}

void RenderPipeline::MakeActive(ID3D11DeviceContext* context)
{
  // bind the non-optional stages
  m_vertex->MakeActive(context);
  m_pixel->MakeActive(context);
  
  // bind the NULL-able stages
  if (m_blend)
  {
    m_blend->MakeActive(context);
  }
  else
  {
    // not implemented
  }
  if (m_depth)
  {
    m_depth->MakeActive(context);
  }
  else
  {
    // not implemented
  }
  // not implemented
}

VertexShader* RenderPipeline::GetVertexShader() const
{
  return m_vertex;
}

PixelShader* RenderPipeline::GetPixelShader() const
{
  return m_pixel;
}
