#include "Graphics/Shaders/ShaderBase.h"
using namespace std;

ShaderBase::ShaderBase(const vector<ID3D11Buffer*>& buffers)
{
  ZeroMemory(m_buffers,sizeof(m_buffers));
  vector<ID3D11Buffer*>::const_iterator buff_it = buffers.begin();
  UINT i = 0;
  while (buff_it != buffers.end()
    && i < D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT)
  {
    m_buffers[i] = *buff_it;
    
    ++buff_it;
    ++i;
  }
}

ShaderBase::~ShaderBase()
{
  for (int i = 0; i < D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT; ++i)
  {
    if (m_buffers[i])
    {
      m_buffers[i]->Release();
    }
  }
}

void ShaderBase::SetConstantBuffer(ID3D11DeviceContext* context,
  UINT id,const void* val)
{
  context->UpdateSubresource(m_buffers[id],0,NULL,val,0,0);
}

ID3D11Buffer*const* ShaderBase::GetBuffers() const
{
  return m_buffers;
}
