#include "Graphics/Shaders/VertexShader.h"
using namespace std;

VertexShader::VertexShader(ID3D11VertexShader* vertex,
  ID3D11InputLayout* layout,const vector<ID3D11Buffer*>& buffers)
:ShaderBase(buffers),
 m_vertex(vertex),
 m_vertex_layout(layout)
{
}

VertexShader::~VertexShader()
{
  m_vertex_layout->Release();
  m_vertex->Release();
}

void VertexShader::MakeActive(ID3D11DeviceContext* context)
{
  // make the vertex shader layout active
  context->IASetInputLayout(m_vertex_layout);
  
  // make the vertex shader active
  context->VSSetShader(m_vertex,NULL,0);
  
  // send the constant buffers
  context->VSSetConstantBuffers(0,
    D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT,GetBuffers());
}

void VertexShader::UpdateConstantBuffers(ID3D11DeviceContext* context)
{
  // send the constant buffers
  context->VSSetConstantBuffers(0,
    D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT,GetBuffers());
}
