#include "Graphics/TextureSampler.h"
#include "log.h"

TextureSampler* TextureSampler::Create(D3D11_SAMPLER_DESC desc,
  D3D11_Core& graphics)
{
  ID3D11SamplerState* sampler = NULL;
  if (FAILED(graphics.GetDevice()->CreateSamplerState(&desc,&sampler)))
  {
    log_print("Failed to create texture sampler\n");
    return NULL;
  }
  
  return new TextureSampler(sampler);
}

TextureSampler::TextureSampler(ID3D11SamplerState* sampler)
:m_sampler(sampler)
{
}

TextureSampler::~TextureSampler()
{
  m_sampler->Release();
}

ID3D11SamplerState* TextureSampler::GetTextureSampler() const
{
  return m_sampler;
}
