#include "Graphics/Viewports.h"

Viewports::Viewports()
:m_next(0)
{
}

Viewports::~Viewports()
{
}

void Viewports::MakeActive(ID3D11DeviceContext* context)
{
  context->RSSetViewports(m_next,m_viewports);
}

bool Viewports::MakeActive(ID3D11DeviceContext* context,UINT start,UINT num)
{
  if (start >= GetNumInUse() || (start + num - 1) >= GetNumInUse())
  {
    return false;
  }
  else
  {
    context->RSSetViewports(num,m_viewports + start);
    return true;
  }
}

bool Viewports::SetNextViewport(const D3D11_VIEWPORT& viewport)
{
  if (m_next >= D3D11_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE)
  {
    return false;
  }
  else
  {
    m_viewports[m_next++] = viewport;
    return true;
  }
}

bool Viewports::SetViewport(UINT index,const D3D11_VIEWPORT& viewport)
{
  if (index >= m_next)
  {
    return false;
  }
  else
  {
    m_viewports[index] = viewport;
    return true;
  }
}

bool Viewports::GetViewport(UINT index,D3D11_VIEWPORT& viewport) const
{
  if (index >= m_next)
  {
    return false;
  }
  else
  {
    viewport = m_viewports[index];
    return true;
  }
}

UINT Viewports::GetNumInUse() const
{
  return m_next;
}

UINT Viewports::GetMaxViewports()
{
  return D3D11_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE;
}
